var sqlite3 = require('sqlite3');
var open = require('sqlite').open;

var repository = {
    create: async (entity) => {
        // Inserts entity in db table, id should be missing and autogenerated
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('INSERT INTO answer (question_id, content) VALUES (@question_id, @content)',
            { '@question_id': entity.question_id, '@content': entity.content });

        await db.close();
        return result;
    },
    update: async (entity) => {
        // Updates entity of given id in db table
        // TODO: check if entity exists

        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('UPDATE answer SET content = @content WHERE id = @id',
            { '@content': entity.content, '@id': entity.id });

        await db.close();
        return result;
    },
    delete: async (id) => {
        // Deletes entity of given id from db table
        // TODO: check if entity exists

        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        let result = await db.run('DELETE FROM answer WHERE id = @id',
            { '@id': id });

        await db.close();
        return result;
    },
    exists: async (id) => {
        // Returns True if entity with given id exists in db table, false otherwise
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM answer WHERE id = @id',
            { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close();
        return result != null;
    },
    count: async () => {
        // Returns total number of entities in db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM answer');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close();
        return result.length;
    },
    findById: async (id) => {
        // Returns entity with given id from db table, null if not existent
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM answer WHERE id = @id', { '@id': id });

        let result = await stmt.get();
        await stmt.finalize();

        await db.close()
        return result;
    },
    getAll: async () => {
        // Returns all entites from db table
        const db = await open({
            filename: '../database.db',
            driver: sqlite3.Database
        });

        const stmt = await db.prepare('SELECT * FROM answer');

        let result = await stmt.all();
        await stmt.finalize();

        await db.close()
        return result;
    },
}

module.exports = repository;